AutoCad - Lisp para calcular peso según area y espesor (tambien suma y exporta a excel)

 
Vista:
sin imagen de perfil
Val: 100
Ha mantenido su posición en AutoCad (en relación al último mes)
Gráfica de AutoCad

Lisp para calcular peso según area y espesor (tambien suma y exporta a excel)

Publicado por Juanma (36 intervenciones) el 23/08/2019 23:51:24
Buenas,

tengo creada la siguiente lisp, (copiando de aquí y de allá) pensada para calcular pesos de chapas (polilineas cerradas).
estoy bastante contento con ella, ya que me inserta un texto, en el centro de cada polilinea peso y área, otro con el total, y te da la opción de crear un listado también en excel.

PERO.... tal y como tengo programado el calculo del centro de cada polilinea, a veces da error, y normalmente es siempre que tiene la polilinea dos vértices superpuestos, o no está exactamente a cota 0...
El caso es a veces no encuentro el fallo, y me fastidia el sumatorio, la numeración, el orden en excel....

Voy a subir el código y a ver si alguno de los expertos del lugar ( egemmm gerardo.... egemm ;) ) le echa un vistazo y me corrige alguna parte

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
328
329
330
331
332
333
334
335
336
337
338
339
340
341
342
343
344
345
346
347
348
349
350
351
352
353
354
355
356
357
358
359
360
361
362
363
364
365
366
367
368
369
370
371
372
373
374
375
376
377
378
379
380
381
382
383
384
385
386
387
388
389
390
391
392
393
394
395
396
397
398
399
400
401
402
403
404
405
406
407
408
409
410
411
412
413
414
415
416
417
418
419
420
421
422
423
424
425
426
427
428
429
430
431
432
433
434
435
436
437
438
439
440
441
442
443
444
445
446
447
448
449
450
451
(vl-load-com)
(defun c:KGa (/		    cmd0	  dimz0		seleccion
	      opcionesmenu  contador	  contador3	volumen1
	      volumen2	    decimales	  volumen3	volumen
	      nombreent	    objetovla	  tkilogramos3	factor
	      factor2	    cant	  conversion	tkilogramos
	      kilogramos    kilogramos3	  escala	puntodeturno1
	      puntodeturno  datosaexcel	  areaenm2	areaenm21
	      areaopeso
	     )
 
 
  (SETQ	areaopeso
	 (GETint
	   "que quierescalcular? (1=peso/2=area/otro=ambos<ambos>):"
	 )
  )
  (IF (and (/= areaopeso 1) (/= areaopeso 2))
    (SETQ areaopeso 3)
  )
 
  (SETQ decimales 2)
 
  (setq kilogramos3 0.00)
  (setq kilogramos 0.00)
   (setq contador2 1)
 
 
(SETQ factor2 1)
  (SETQ factor 7850)
  (IF (/= areaopeso 2)
 
 
    (SETQ factor2 (GETint "espesor en mm:"))
  )
  (IF (= factor2 nil)
    (SETQ factor2 1)
  )
 
  (IF (/= areaopeso 2)
    (SETQ factor (GETint "densidad (actual 7850 Kg/m3): "))
  )
(setq datosaexcel 0)
  (IF (= factor nil)
    (SETQ factor 7850)
  )
  (setq finalizar 1)
  (if (= contador2 nil)
    (setq contador2 1)
  )
  (setq contador3 contador2)
  (SETQ	contador2
	 (GETINT (strcat "\nIndica numeración <numeración actual:"
			 (itoa contador2)
			 ">:"
		 )
	 )
  )
  (if (= contador2 nil)
    (setq contador2 contador3)
  )
  (setq escala 1000000000.00)
 
 
 
  (SETQ	datosaexcel
	 (GETINT (strcat "\n¿exportar a excel?(1=si/0=no,<"
			 (itoa datosaexcel)
			 ">:"
		 )
	 )
  )
  (if (= datosaexcel nil)
    (setq datosaexcel 0)
  )
 
  (if (and (/= datosaexcel 1) (/= datosaexcel 0))
    (setq datosaexcel 0)
  )
 
  (if (= datosaexcel 1)
    (setq archivo (getfiled "Selecciona archivo de destino" "" "xls" 1))
  )
  (if (= datosaexcel 1)
    (setq arch (open archivo "w"))
  )
 
 
 
 
  (setq contador 0)
  (setq seleccion nil)
  (if (= (setq cmd0 (getvar "cmdecho")) 1)
    (setvar "cmdecho" 0)
  )
  (setq dimz0 (getvar "dimzin"))
  (setvar "dimzin" 0)
 
					;-----------
 
 
 
  (defun _centroid (space objs / reg cen)
    (setq reg (car (vlax-invoke space 'addregion objs))
	  cen (vlax-get reg 'centroid)
    )
    (vla-delete reg)
    (trans cen 1 0)
  )
 
 
					;----------------------------------------------------------------
  (setq opcionesmenu "")
 
 
  (while opcionesmenu
    (initget "Espesor Densidad Nºdecimales")
 
 
    (setq textoopciones
	   (strcat "\nEspesor<"
		   (itoa factor2)
		   "> / Densidad<"
		   (itoa factor)
		   ">  / Nºdecimales<"
		   (itoa decimales)
		   "> / [select objet]:"
	   )
    )
    (setq puntodeturno (getpoint textoopciones))
 
 
 
 
 
 
 
					;----------------------------------------------------------------
 
 
 
 
    (setq opcionesmenu
 
	   (cond
 
	     (				;si el usuario pulsa E
	      (eq puntodeturno "Espesor")
	      (setq espesorprevio factor2)
 
	      (setq
		factor2	(getint (strcat "\nEspesor en mm<" factor2 ">:"))
	      )
 
	      (if (= factor2 nil)
		(setq factor2 espesorprevio)
	      )
 
	      (princ "\nEspesor: ")
	      (princ factor2)
 
	      (setq opcionesmenu "")
	     )
 
	     (				;si el usuario pulsa D
	      (eq puntodeturno "Densidad")
	      (setq Densidadprevia factor)
 
	      (setq factor (getint (strcat "\nEspesor en mm<" factor ">:")))
 
	      (if (= factor nil)
		(setq factor2 Densidadprevia)
	      )
 
	      (princ "\nDensidad: ")
	      (princ factor)
 
	      (setq opcionesmenu "")
	     )
 
 
 
 
	     (				;si el usuario pulsa N
	      (eq puntodeturno "Nºdecimales")
	      (setq Decimalesprevio decimales)
 
	      (setq decimales
		     (getint (strcat "\nEspesor en mm<" decimales ">:")
		     )
	      )
 
	      (if (= decimales nil)
		(setq decimales Decimalesprevio)
	      )
 
	      (princ "\nNº de decimales: ")
	      (princ decimales)
 
	      (setq opcionesmenu "")
	     )
 
 
 
	     (				;si la respuesta del usuario es seleccionar objetos...
	      (eq (type puntodeturno) 'LIST)






					;----------------------------------------------------------------




	      (while (not seleccion)
		(setq seleccion
		       (ssget
			 '((0
			    .
			    "ARC,CIRCLE,ELLIPSE,HATCH,*POLYLINE,REGION,SPLINE"
			   )
			  )
		       )
		      contador 0
		)
 
	      )
	      (setq volumen1 0.00)
 
	      (setq volumen 0.00)
 
	      (setq areaenm21 0)
 
	      (setq acdoc (vla-get-activedocument (vlax-get-acad-object))
 
		    acspc (vlax-get-property
			    acdoc
			    (if	(= 1 (getvar 'CVPORT))
			      'Paperspace
			      'Modelspace
			    )
			  )

	      )
;;;Repeat - gerardogqa 

	      (repeat (sslength seleccion)

		(setq

		  nombreent (ssname seleccion contador)


		  contador2 (1+ contador2)

		  contador  (1+ contador)

		  objetovla (vlax-ename->vla-object nombreent)

		  pt0	    (_centroid acspc (list objetovla))


		)

		(setq volumen1 (vla-get-area objetovla))


		(setq volumen3 (/ volumen1 escala))

		(setq areaenm2 (* volumen3 1000))



		(setq volumen3 (* volumen3 factor2))


		(setq kilogramos3 (* volumen3 factor))



		(IF (= areaopeso 1)

		  (setq	tkilogramos3
			 (strcat (itoa contador2)
				 "- \t"


				 (rtos kilogramos3 2 decimales)
				 " Kg"

			 )
		  )

		  (IF (= areaopeso 2)

		    (setq tkilogramos3
			   (strcat (itoa contador2)
				   "- \t"
				   (rtos areaenm2 2 decimales)
				   " m²"
			   )
		    )

		    (setq tkilogramos3
			   (strcat (itoa contador2)
				   "- \t"
				   (rtos kilogramos3 2 decimales)
				   " Kg   \t"
				   (rtos areaenm2 2 decimales)
				   " m²"
			   )
		    )

		  )

		)

					; (if (null alturatexto)

		(setq alturatexto 

20)

;(getvar "TEXTSIZE"))

					;)


		(if (= datosaexcel 1)

		  (write-line tkilogramos3 arch)

		)





		(command "_text" "_mc" pt0 alturatexto "" tkilogramos3)





		(setq areaenm21 (+ areaenm21 areaenm2))

		(setq kilogramos (+ kilogramos3 kilogramos))

	      )



					;  (setq volumen (/ volumen escala))


					; (setq volumen2 (* volumen factor2))


					; (setq kilogramos (* volumen2 factor))



	      (IF (= areaopeso 1)

		(setq tkilogramos
		       (strcat (rtos kilogramos 2 decimales) " Kg")
		)

		(IF (= areaopeso 2)

		  (setq	tkilogramos
			 (strcat (rtos areaenm21 2 decimales) " m²")
		  )

		  (setq	tkilogramos
			 (strcat (rtos kilogramos 2 decimales)
				 " Kg   \t"
				 (rtos areaenm21 2 decimales)
				 " m²"
			 )
		  )

		)

	      )





	      (princ "\n Unidades: milimetros")



	      (princ "\nkilogramos total de componentes: ")

	      (princ tkilogramos)



	      (setq alturatexto (getvar "TEXTSIZE"))


	      (setq puntodeturno (getpoint "\ndar punto para texto"))

	      (command "_text"	     "_mc"	   puntodeturno
		       alturatexto   ""		   tkilogramos
		      )


	      (if (= datosaexcel 1)
		(write-line (strcat "Total:" "\t" tkilogramos) arch)

	      )




	      (if (= 0

		     (GETINT (strcat "\nterminar archivo?(1=no, 0=si)"
				     (itoa finalizar)
				     ":"
			     )
		     )
		  )
		(setq finalizar 0)
	      )


					; (setvar "dimzin" dimz0) 
					; (if (= cmd0 1) 
					; (setvar "cmdecho" 1) )



	     )
	     (if
	      (= datosaexcel 1)
					;(close arch)
	     )
	   )
    )
  )
					;)
					;(close arch)
  (princ)
)

Muchas gracias, pongo tambien el archivo para descarga
Valora esta pregunta
Me gusta: Está pregunta es útil y esta claraNo me gusta: Está pregunta no esta clara o no es útil
0
Responder
sin imagen de perfil
Val: 100
Ha mantenido su posición en AutoCad (en relación al último mes)
Gráfica de AutoCad

Actualizo

Publicado por Juanma (36 intervenciones) el 24/08/2019 11:59:30
El codigo que me da error es este:
1
(setq  pt0  (_centroid acspc (list objetovla))
y me da error cuando la polilinea tiene algun error como un vertice doble, o un pliege etc... el caso es que se que es ese codigo por que he hecho otra que situa el texto en el primer vertice de la polilinea y entonces funciona.

Resumiendo, quisiera saber como gestionar un error, osea, no solo que de nil, sino que de error al ejecutarse, como es el caso.

quisiera saber decirle: "calcula esto, pero si da nil o da error, entonces haz esto otro"

Gracias de antemano.
Valora esta respuesta
Me gusta: Está respuesta es útil y esta claraNo me gusta: Está respuesta no esta clara o no es útil
0
Comentar
sin imagen de perfil
Val: 100
Ha mantenido su posición en AutoCad (en relación al último mes)
Gráfica de AutoCad

Actualizo

Publicado por Juanma (36 intervenciones) el 24/08/2019 15:51:33
Ya he reparado el codigo, usando el calculo del centro que nos ofrece la web http://www.lee-mac.com que es MUY recomendable.
Aun así sigo queriendo saber como gestionar errores, subiré un dwg con una muestra de las polilineas a las que les estaba calculando el peso, incluida la que me proboca el error en la rutina.
Valora esta respuesta
Me gusta: Está respuesta es útil y esta claraNo me gusta: Está respuesta no esta clara o no es útil
0
Comentar